--
-- PostgreSQL database dump
--

-- Dumped from database version 9.2.18
-- Dumped by pg_dump version 9.6.3

-- Started on 2017-09-26 14:22:00

SET statement_timeout = 0;


SET client_encoding = 'UTF8';
SET standard_conforming_strings = on;
SET check_function_bodies = false;
SET client_min_messages = warning;


--
-- TOC entry 8 (class 2615 OID 34990)
-- Name: maintenance; Type: SCHEMA; Schema: -; Owner: i3dhub
--

CREATE SCHEMA maintenance;


ALTER SCHEMA maintenance OWNER TO i3dhub;

SET search_path = maintenance, pg_catalog, extensions;


-- Table: maintenance.versioning

-- DROP TABLE maintenance.versioning;

CREATE TABLE maintenance.versioning
(
  object_type character varying(2),
  object_version integer,
  CONSTRAINT "PK_Object_Type" PRIMARY KEY (object_type)
)
WITH (
  OIDS=FALSE
);
ALTER TABLE maintenance.versioning
  OWNER TO i3dhub;




--
-- TOC entry 232 (class 1255 OID 34994)
-- Name: clear_data(); Type: FUNCTION; Schema: maintenance; Owner: i3dhub
--

CREATE FUNCTION clear_data() RETURNS void
    LANGUAGE plpgsql
    AS $$BEGIN
TRUNCATE l3d.cache RESTART IDENTITY CASCADE;
TRUNCATE l3d.aux_node_to_aux_node RESTART IDENTITY CASCADE;
TRUNCATE l3d.aux_attributes RESTART IDENTITY CASCADE;
TRUNCATE l3d.metadata RESTART IDENTITY CASCADE;
END;
$$;


ALTER FUNCTION maintenance.clear_data() OWNER TO i3dhub;


-- FUNCTION: maintenance.clean_data()

-- DROP FUNCTION maintenance.clean_data();

CREATE OR REPLACE FUNCTION maintenance.clean_data(
	)
RETURNS void
    LANGUAGE 'plpgsql'
    COST 100
    VOLATILE 

AS $BODY$
BEGIN
PERFORM l3d.su_del_cache_by_ids( ARRAY(
        SELECT id FROM l3d.cache WHERE active = false));

UPDATE l3d."cache" co set active = false
       FROM l3d."cache" cn
       WHERE
        co.uuid = cn.uuid                   and 
        co.ext_cache_id0 = cn.ext_cache_id0 and 
        co.ext_cache_id1 = cn.ext_cache_id1 and 
        co.id < cn.id                       and
        co.active;
END;

$BODY$;

ALTER FUNCTION maintenance.clean_data()
    OWNER TO i3dhub;


-- FUNCTION: maintenance.is_uptodate(integer, integer)

-- DROP FUNCTION maintenance.is_uptodate(integer, integer);

CREATE OR REPLACE FUNCTION maintenance.is_uptodate(
	o_tbversion integer,
	o_pcversion integer)
RETURNS boolean
    LANGUAGE 'plpgsql'
    COST 100
    VOLATILE 
AS $BODY$
DECLARE isTBUpdated boolean;
DECLARE isSPUpdated boolean;
DECLARE isUpdated boolean;
BEGIN
 PERFORM * FROM maintenance.versioning WHERE object_type = 'TB' AND object_version = o_tbversion;
 IF FOUND THEN
 isTBUpdated := true;
ELSE 
 isTBUpdated :=false;
END IF;

PERFORM * FROM maintenance.versioning WHERE object_type = 'SP' AND object_version = o_pcversion;
IF FOUND THEN
 isSPUpdated := true;
ELSE 
 isSPUpdated :=false;
END IF;


IF isSPUpdated AND isTBUpdated THEN
	isUpdated:=true;
ELSe
		isUpdated:=false;
END IF;

RETURN isUpdated;
END;

$BODY$;

ALTER FUNCTION maintenance.is_uptodate(integer, integer)
    OWNER TO i3dhub;




-- FUNCTION: public.get_ir3d_aux_by_id(bigint, bigint, refcursor)

-- DROP FUNCTION public.get_ir3d_aux_metadata(bigint, bigint);

CREATE OR REPLACE FUNCTION maintenance.dump_aux_metadata(
	p_uuid character varying,
	p_cid0 integer,
	p_cid1 integer,
	aux_id bigint)
RETURNS TABLE
	(type text,
	 name character varying,
	value character varying)
    LANGUAGE 'plpgsql'
    COST 100
    VOLATILE 
AS $BODY$
DECLARE c_id bigint;
BEGIN

SELECT l3d.get_cache(p_uuid,p_cid0,p_cid1) INTO c_id;
	
RETURN QUERY 
	SELECT 'property' as type, 'auxType' as name , ant.name as value
	FROM l3d.aux_node as an, l3d.aux_node_type as ant
	WHERE an.aux_node_id = aux_id
	AND an.cache_id = c_id
	AND an."AUXNodeType_ID" = ant.id
UNION 
 	
	SELECT 'attribute' as type, aat.key as name, aat.value as value
	FROM l3d.aux_attributes as aat, l3d.aux_node as an
	WHERE an.id = aat.aux_node_id
	AND an.id =  (SELECT id FROM public.l3d.aux_node as an WHERE aux_node_id =aux_id AND an.cache_id = c_id)
	

UNION 

	SELECT 'property' as type ,avt.name as name, COALESCE(av.value_str,av.value_num::text) as value 
	FROM l3d.aux_value as av, l3d.aux_node as an, l3d.aux_value_name as avt, l3d.aux_node_type as ant
	WHERE av.aux_value_name_id = avt.id
	AND an.id = av.aux_node_id
	AND an.aux_node_type_id = ant.id
	AND an.id =  (SELECT id FROM l3d.aux_node as an WHERE aux_node_id = aux_id AND an.cache_id = c_id)

UNION 

	SELECT 'ref'as type , 'nodeId' as name, an.aux_node_id::text as value
	FROM l3d.aux_node as an, l3d.aux_node_to_aux_node as ansp  
    WHERE ansp.succ_id = (SELECT id FROM l3d.aux_node as an WHERE aux_node_id = aux_id AND an.cache_id = c_id) 
    AND ansp.pred_id = an.id
    


order by type;

END;

$BODY$;

ALTER FUNCTION maintenance.dump_aux_metadata(character varying,integer,integer, bigint)
    OWNER TO i3dhub;





--
-- TOC entry 2927 (class 0 OID 0)
-- Dependencies: 8
-- Name: maintenance; Type: ACL; Schema: -; Owner: i3dhub
--

REVOKE ALL ON SCHEMA maintenance FROM PUBLIC;
REVOKE ALL ON SCHEMA maintenance FROM i3dhub;
GRANT ALL ON SCHEMA maintenance TO i3dhub;

INSERT INTO maintenance.versioning(
	object_type, object_version)
	VALUES ('TB', 0);
INSERT INTO maintenance.versioning(
	object_type, object_version)
	VALUES ('SP', 0);
INSERT INTO maintenance.versioning(
	object_type, object_version)
	VALUES ('TS', 0);
INSERT INTO maintenance.versioning(
	object_type, object_version)
	VALUES ('PS', 0);


-- Completed on 2017-09-26 14:22:00

--
-- PostgreSQL database dump complete
--

