--
-- disableConstrains script to disable all foreign key constrains on tables.
-- To be executed when constrains are needed to be disabled.
-- Disabling constrains make the insertion and update statements faster.
--

-- DISABLE TRIGGER ALL is not possible unless running as super user. not even
-- the aws provisioned user seems to be able to do this

-- cache tables
ALTER TABLE l3d.shape                     DISABLE TRIGGER ALL;
ALTER TABLE l3d.shape_instance            DISABLE TRIGGER ALL;

ALTER TABLE l3d.edge                      DISABLE TRIGGER ALL;
ALTER TABLE l3d.edge_instance             DISABLE TRIGGER ALL;
ALTER TABLE l3d.edge_instance_to_aux_node DISABLE TRIGGER ALL;

ALTER TABLE l3d.face                      DISABLE TRIGGER ALL;
ALTER TABLE l3d.face_instance             DISABLE TRIGGER ALL;
ALTER TABLE l3d.face_instance_to_aux_node DISABLE TRIGGER ALL;

ALTER TABLE l3d.node                      DISABLE TRIGGER ALL;
ALTER TABLE l3d.aux_node                  DISABLE TRIGGER ALL;
ALTER TABLE l3d.aux_node_type             DISABLE TRIGGER ALL;

ALTER TABLE l3d.aux_value                 DISABLE TRIGGER ALL;
ALTER TABLE l3d.aux_value_name            DISABLE TRIGGER ALL;

ALTER TABLE l3d.aux_attributes            DISABLE TRIGGER ALL;

ALTER TABLE l3d.metadata                  DISABLE TRIGGER ALL;
ALTER TABLE l3d.aux_node_to_aux_node      DISABLE TRIGGER ALL;

ALTER TABLE l3d.tag_name                  DISABLE TRIGGER ALL;
ALTER TABLE l3d.tags_values               DISABLE TRIGGER ALL;

ALTER TABLE l3d.data_stats                DISABLE TRIGGER ALL;

-- indexl3d tables
ALTER TABLE l3d.index_cache               DISABLE TRIGGER ALL;
ALTER TABLE l3d.index_properties          DISABLE TRIGGER ALL;
ALTER TABLE l3d.index_source              DISABLE TRIGGER ALL;
ALTER TABLE l3d.index_stats               DISABLE TRIGGER ALL;

--ALTER TABLE public."ir3d_Cache" ENABLE TRIGGER ALL;
